/*
 Licensed Materials - Property of IBM
 5724-T40 IBM License Metric Tool
 5725-C68 IBM Tivoli Asset Discovery for Distributed
 (C) Copyright IBM Corp. 2002, 2011.
 All Rights Reserved. US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 For more detailed help, refer to product manual.
 */

var table1;
var button;
var bundleOptionsLayout;
var bundleOptionsForMultipleComponentsLayout;
var dialog;
var jsonStore1;
var mAreaInfo;
var mAreaInfo1;
var bundleConnectionLinks = [];
		
bundleOptionsLayout = [ {
	field : "productName",
	name : resourceBundle.TableColumnProductName,
	width : '50%',
	formatter : displayText
}, {
	field : "confidenceLevel",
	name : resourceBundle.TableColumnConfidenceLevel,
	width : '20%',
	formatter : displayPercentage,
	datatype: "number"
}, {
	field : "appliedRules",
	name : resourceBundle.TableColumnApplicableRules,
	width : '30%',
	formatter : displayText
} ];


bundleOptionsForMultipleComponentsLayout = [ {
	field : "productName",
	name : resourceBundle.TableColumnProductName,
	width : '70%',
	formatter : displayText
}, {
	field : "minConfidenceLevel",
	name : resourceBundle.TableColumnMinimalConfidenceLevel,
	width : '30%',
	formatter : displayPercentage,
	datatype: "number"
} ];

function showReassignedLabel(numberOfInstances){
	dojo.html.set(dojo.byId("shareReassingedLabel"),formatLabel(resourceBundle.NumberOfInstances, ""+numberOfInstances));
};

function showReassignedReleasesLabel(numberOfReleases){
	dojo.html.set(dojo.byId("shareReassingedLabel"),formatLabel(resourceBundle.NumberOfReleases, ""+numberOfReleases));
};

function showDialog() {
	// set the content of the dialog:
	dialog = new dijit.Dialog(
			{
				id : 'dialog1',
				title : resourceBundle.DialogTitle.replace(/&#39;/g,"'"),
				onHide : closeDialog,
			});


	// prepare container to dialog content
	var bc = new dijit.layout.BorderContainer({
		style: "height: 400px; width: 700px;",
		gutters: false
	});	

	var tableText = prod_inv_id_complex.length < 2 ? 
			'' :  '<br/><div>' + resourceBundle.TableMultipleSelectedInfo + '</div>';

	var dialogLabel= '<div id="messageAreaInfo" dojoType="dojoe.messagearea.MessageArea"></div>';
	dialogLabel+= '<div id="messageAreaInfo2" dojoType="dojoe.messagearea.MessageArea" style="overflow:auto"></div>';
	dialogLabel+= '<div id="messageAreaInfo3" dojoType="dojoe.messagearea.MessageArea" style="overflow:auto"></div>';	
	dialogLabel+='<div width="100%" id="shareReassingedLabel">&nbsp;</div>';
	dialogLabel+= tableText;
		
	cp1 = new dijit.layout.ContentPane({
	   region: "top",
	   style: "height: 50px;",
	   splitter: true,
	   content: dialogLabel
	});
	bc.addChild(cp1);
	
	var cp2 = new dijit.layout.ContentPane({
	   region: "center",
	   content: '<div id="Table_Programmatic1" style="width: 100%;"></div>'
	});
	bc.addChild(cp2);
	
	var cp3 = new dijit.layout.ContentPane({
	   region: "bottom",
	   style: "text-align:right",
	   content: '<div id="buttonClose"></div>'	   
	});
	bc.addChild(cp3);
	
	bc.startup();
	
	dialog.attr("content", bc);
	dojo.parser.parse();
	mAreaInfo = dijit.byId('messageAreaInfo');
	if (isSimpleSelected){
		mAreaInfo.setType("info");
		mAreaInfo.setMessage(resourceBundle.TableSimpleSkippedInfo);
		mAreaInfo.setWidth("100%");
		mAreaInfo.show();
	} else {
		mAreaInfo.hide();
	}
	
	//Will show the number of selected instances.
        if (releases.length == 0)
        {
	showReassignedLabel(""+prod_inv_id.length);
        } else {
	  showReassignedReleasesLabel(""+releases.length); //fixme: change label text to releases instead of instances
        }
	
	mAreaInfo1 = dijit.byId('messageAreaInfo2');
	mAreaInfo1.setType("info");
	mAreaInfo1.setMessage(resourceBundle.TargetTableShareProductHintText);
	mAreaInfo1.setWidth("100%");
	mAreaInfo1.hide();
	mAreaInfo3 = dijit.byId('messageAreaInfo3');
	mAreaInfo3.setType("info");
	mAreaInfo3.setMessage("<empty>");
	mAreaInfo3.setWidth("100%");
	mAreaInfo3.hide();
	
	setTimeout(dojo.hitch(this, function(){showTable();}), 200); //this prevents error occurrence while table data loading  
	showButton();
	//dojo.connect(table1, "resize", dialog, "resize"); 
	dialog.show();
};

function closeDialog() {
	
	var localObjectsToDestroy = {};
	
	localObjectsToDestroy["otherObjects"] = [table1];
	localObjectsToDestroy["connections"] = bundleConnectionLinks;
	localObjectsToDestroy["store"] = jsonStore1;
	localObjectsToDestroy["mainDialog"] = dialog;
	
	closeAndDestroyAll(localObjectsToDestroy); 
	
	table1 = null;
	bundleConnectionLinks = [];
	jsonStore1 = null;
	dialog = null;
};

function bundleCloseDialog() {
	var deferred = table1.grid.selection.getSelectedItems();
	deferred.then(function(selected){
      //Do something on success.
		if(selected.length<1){
			button.set('disabled', true);
			return;
		}
		
        if (releases.length == 0) // instance mode
        {
		var prodInv = arrayToString(prod_inv_id_complex);
		var updateTimes = arrayToString(updateTime_complex);
		var formData =
			"mode=instance&target=bundle&productInventoryId="	+ prodInv
			+ "&productId="	+ jsonStore1.getValue(selected[0],'productId')
			+ "&updateTime=" + updateTimes;
                } else {
		var relIds = arrayToString(releases);
		var formData =
			"mode=release&target=bundle&releases="+ relIds
                        + "&productId="	+ jsonStore1.getValue(selected[0],'productId')
			+ "&&filterText="+quickFilter
                        + "&startDate="+resourceBundle.startDate
                        + "&endDate="+resourceBundle.endDate
                        + "&confMin="+confMin
                        + "&confMax="+confMax
                        + "&viewType="+resourceBundle.viewType
                        + "&columnFilterMapping="+getColumnFilterMappingAsString()
                        + "&"+buildColumnFilterParameterAsString();
                }
        
        formData = formData + "&sessionId=" + sessionId;

		button.set('disabled', true);
		button.focus();

		var dialog1 = showProgressDlgIndicator('dialod2',resourceBundle.DialogTitle);
		
		var localObjectsToDestroy = {};
		
		localObjectsToDestroy["progressDlg"] = dialog1;
		localObjectsToDestroy["otherObjects"] = [table1, mAreaInfo1, mAreaInfo];
		localObjectsToDestroy["connections"] = bundleConnectionLinks;
		localObjectsToDestroy["store"] = jsonStore1;
		localObjectsToDestroy["mainDialog"] = dialog;
		
		sendServletRequestAndCleanup('POST', 'ActionServlet', formData, localObjectsToDestroy, undefined);
		
    },
    function(error){
      //Do something on failure.
		console.log(error);
});

};

function showButton() {
	button = new dijit.form.Button( {
		showLabel : true,
		label : resourceBundle.ButtonBundleText,
		disabled : true,
		onClick : bundleCloseDialog
	}, 'buttonClose');
};

function showTable() {
	jsonStore1 = new dojox.data.QueryReadStore( {
		url : resourceBundle.contextPath +"/JsonRenderServlet?sessionId="+sessionId,
		requestMethod : "post",
		doClientPaging:true,
		doClientSorting:true
	});
	
	createBundleTableWidgets();
	
	//changeGetSelectedFunction(table1);

	bundleConnectionLinks.push(dojo.connect(table1, "onClick", function(item) {
			var deferred = table1.grid.selection.getSelectedItems();
			deferred.then(function(selected){
		      //Do something on success.
				button.set('disabled', (selected.length<1));
		    },
		    function(error){
		      //Do something on failure.
				console.log(error);
		});

	}));
	
	var firstFetch = true;
	bundleConnectionLinks.push(dojo.connect(table1.grid, "_onFetchComplete", function(items, req){
		if (firstFetch) {
			var items2=jsonStore1._items;
			for(i=0; i<items2.length; i++) {
				if (items2[i]['i']['isShared'] === 'true') {
					mAreaInfo1.show();
					break;
				}
			}
			if (jsonStore1._labelAttr != 'name')
			{
			 mAreaInfo3.setMessage(jsonStore1._labelAttr.split('|')[2]);
			 mAreaInfo3.show();			
			}
			firstFetch = false;
		}
	}));

	table1.grid.onFetchError = dojo.hitch(this, onFetchErrorHandler);
};


function createBundleTableWidgets() {	
	   var tableLayout;
        if (releases.length == 0)
        {
          tableLayout = prod_inv_id_complex.length < 2 ? bundleOptionsLayout : bundleOptionsForMultipleComponentsLayout;	
          var ids = prod_inv_id_complex.join(",");        
          var query = {
              target : "table",
              mode : "instance",
              productInventoryId : ids
            };          
        } else {
          tableLayout = nmbOfInstancesInSelectedReleases < 2 ? bundleOptionsLayout : bundleOptionsForMultipleComponentsLayout;
          var ids = releases.join(",");
          var quickFilter = getQuickFilterTextNotEncoded();
          var query = {
              target : "table",
              mode : "release",
              releases : ids,
              filterText:quickFilter, 
              startDate:resourceBundle.startDate, 
              endDate:resourceBundle.endDate, 
              confMin:confMin, 
              confMax:confMax,
              viewType:resourceBundle.viewType,
              columnFilterMapping:getColumnFilterMappingAsString()
            };
          
          setFilterParamsInQuery(query);
	 
        }
	
	table1 = new dojoe.table.Table( {
		width : '100%',
		height : '100%',
		gridParams : {
              query : query,
			queryOptions : {
				"deep" : true
			},
			structure : tableLayout,
			store : jsonStore1,
			selectionMode : 'single',
			plugins : {
					indirectSelection : true,
					nestedSorting : true,
					dnd : true,
					filter : {
						advancedFilter : true,
						quickFilter : true,
						ruleCount : 0,
						showQuickFilterButton : true
					},
					selector : {
						noClear: true, cell: false
					},
					pagination : false
			}
		},
		toolbarOptions : {
				refreshIcon:false,
				actionMenu:false,
				configTableIcon:false, configTableMenu: false,
				exporterIcon: false, exporterMenu: false,
				printerIcon:false, printerMenu: false											
		}
	}, 'Table_Programmatic1');
	
	table1.startup();
}
