/*
 Licensed Materials - Property of IBM
 5724-T40 IBM License Metric Tool
 5725-C68 IBM Tivoli Asset Discovery for Distributed
 (C) Copyright IBM Corp. 2002, 2011.
 All Rights Reserved. US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 For more detailed help, refer to product manual.
 */

//bundle from product
var selectedReleaseName;
var selectedReleaseId;
var jsonStoreBundleFromPrdTable;
var tableBundleFromPrd;
var dialogBundleFromPrd;
var buttonBundleFromPrd;
var prodInvForRebundle=[];
var updateTimeForRebundle=[];
var shareWarningArea;
var instanceConnectionLinks = [];
var selectAllOption = false;

var layoutBundleFromPrd = [ {
	field : "componentNameVersion",
	name : resourceBundle.BundleFromProductTableColumnComponent,
	width : '13',
	formatter : displayText
}, {
	field : "hostname",
	name : resourceBundle.BundleFromProductTableColumnHostname,
	width : '8',
	formatter : displayText
}, {
	field : "path",
	name : resourceBundle.BundleFromProductTableColumnPath,
	width : '13',
	formatter : displayText
}, {
	field : "confidenceLevel",
	name : resourceBundle.BundleFromProductTableColumnConfidenceLevel,
	width : '15',
	formatter : displayPercentage,
	datatype : "number"
}, {
	field : "appliedRules",
	name : resourceBundle.BundleFromProductTableColumnApplicableRules,
	width : '13',
	formatter : displayText
}, {
	field : "productNameVersion",
	name : resourceBundle.BundleFromProductTableColumnProduct,
	width : '13',
	formatter : displayText
} ];

if (!isTAD4D) {
	layoutBundleFromPrd.splice(2, 1);
}

function createInstanceTableWidgets(){
	tableBundleFromPrd = new dojoe.table.Table( {
		width : '100%',
		height : '100%',
		gridParams : {
			query : {
				target : "tableInstances",
				releaseId : selectedReleaseId
			},
			queryOptions : {
				"deep" : true
			},
			structure : layoutBundleFromPrd,
			store : jsonStoreBundleFromPrdTable,
			selectionMode : 'multiple',
			plugins : {
				selector: {noClear: true, cell: false},
				indirectSelection : true,
				nestedSorting : true,
				dnd : true,
				filter : {
					advancedFilter : true,
					quickFilter : true,
					ruleCount : 0,
					showQuickFilterButton : true
				},
				pagination : false
			}
		},
		toolbarOptions : {
			refreshIcon:false,
			actionMenu:false,
			configTableIcon:false, configTableMenu: false,
			exporterIcon: false, exporterMenu: false,
			printerIcon:false, printerMenu: false											
		}
	}, 'TableBundleFromPrd');
	
	tableBundleFromPrd.startup();
	
	tableBundleFromPrd.grid.selection.getSelectedItems = function(pageSize){
		// summary:
		//		This function is an asynchronous implementation of getSelected().
		//		Unlike getSelected, we won't get any null values in the result of this function.
		// pageSize: Integer
		//		To load all selected rows, the grid needs to fetch a lot of data. So it is necessary
		//		to break a huge request into several small requests, so as not to hold up the browser
		//		for too long.
		//		This pageSize parameter is used to specifiy how many rows to fetch in one request.
		//		If not provided or equal to zero, grid.rowsPerPage is used.
		//		If less than zero, then there will be no upper limit to the request size.
		//		If client side store is used, it is recommented to provide a negative pageSize such as -1.
		// return: Deferred Object
		//		The Deferred object representing the result item array.
		// example:
		// |	grid.selection.getSelectedItems().then(function(items){
		// |		//We get all the selected items here.
		// |	});
		var res = [], d = new dojo.Deferred(), defs = [],
			start, i, len, item, toFetch = [], 
			grid = this.grid, _this = this, 
			ps = pageSize || grid.rowsPerPage,
			//Prepare the constant options.
			options = {
				query: grid.query,
				sort: grid.getSortProps(),
				queryOptions: grid.queryOptions,
				onError: dojo.hitch(d, d.errback)
			},
			onComplete = function(def, start, items){
				//Save the fetched items to the result array.
				for(var i = 0, len = items.length; i < len; ++i){
					res[toFetch[start] + i] = items[i];
				}
				def.callback();
			};
		for(i = 0, len = this.selected.length; i < len; ++i){
			if(this.selected[i]){
				item = grid._by_idx[i];
				res[i] = item && item.item;
				if(!item){
					toFetch.push(i);
				}
			}
		}
		for(start = 0, len = toFetch.length; start < len; start = i){
			//Find how many items can we get by one fetch.
			for(i = start + 1; 
					i < len &&
					toFetch[i] === toFetch[i - 1] + 1 &&	//Ensure the item indexes are continuous
					ps < 0 || i - start < ps;		//Paging the request, so we can handle huge stores. 
				++i){}
			var def = new dojo.Deferred();
			var req = dojo.mixin({
				start: toFetch[start],
				count: i - start,
				onComplete: dojo.partial(onComplete, def, start)
			}, options);
			defs.push(def);
			//Check whether we are using EDG
			if(grid._storeLayerFetch){
			    grid._storeLayerFetch(req);
			}else{
			    grid.store.fetch(req);
			}
		}
		(new dojo.DeferredList(defs)).then(function(){
			res = dojo.filter(res, function(item){
				return item;
			});
			if(_this.preserver){
				//Since the grid is paged, some previously selected rows may not be loaded after
				//sorting or filtering, etc. So get these rows from selectedById.
				//Note: the row order can not be honored here! 
				var id, dl = [],
					onItem = function(defer, item){
						res.push(item);
						defer.callback();
					},
					selectedIds = dojo.map(res, function(item){
						return grid.store.getIdentity(item);
					});
				for(id in _this.preserver._selectedById){
					if(_this.preserver._selectedById[id] === true && dojo.indexOf(selectedIds, id) < 0){
						var dd = new dojo.Deferred();
						grid.store.fetchItemByIdentity({
							identity: id,
							onItem: dojo.partial(onItem, dd)
						});
						dl.push(dd);
					}
				}
				if(dl.length){
					(new dojo.DeferredList(dl)).then(function(){
						//Get back to the user.
						d.callback(res);
					});
					return;
				}
			}
			//Get back to the user.
			d.callback(res);
		}, dojo.hitch(d, d.errback));
		return d;
	};

	
}

function showBundleFromPrdDialog() {
	
	dialogBundleFromPrd = new dijit.Dialog(
		{
			id : 'dialogBundleFromPrd',
			title : resourceBundle.BundleFromProductTableTitle.replace(/&#39;/g,"'"),
			onHide : closeBundleFromPrdDialog,
		}
	);

	var bc = new dijit.layout.BorderContainer({
		style: "height: 400px; width: 700px;",
		gutters: false
	});	
	
	var dialogLabel = "<div id='warningArea' dojoType='dojoe.messagearea.MessageArea'></div>";
	dialogLabel +=  "<div style='overflow:auto'><b>";	
	dialogLabel +=	 formatLabel(resourceBundle.BundleFromProductTableTargetRelease,selectedReleaseName); 
	dialogLabel +=  "</b></div>";
	
	var html = '<table border="0" width="100%"><tr><td><div width="100%" id="reassignedInstancesLabel"></div></td>';
	html += '<td align="right" ><div align="right" id="buttonBundleFromPrdClose"></div></td></tr></table>';
	
	var cp1 = new dijit.layout.ContentPane({
		region: "top",
		style: "height: 50px;",
		splitter: true,
		content: dialogLabel
	});
	bc.addChild(cp1);
	
	var cp2 = new dijit.layout.ContentPane({
	   region: "center",
	   content: '<div id="TableBundleFromPrd" style="width: 100%;"></div>'
	});
	bc.addChild(cp2);
	
	var cp3 = new dijit.layout.ContentPane({
	   region: "bottom",
	   content: html	   
	});
	
	bc.addChild(cp3);
	bc.startup();	
	dialogBundleFromPrd.attr("content", bc);
	
	dojo.parser.parse();
	shareWarningArea = dijit.byId('warningArea');
	shareWarningArea.setType("info");
	shareWarningArea.setWidth("100%");
	shareWarningArea.hide();
	showBundleFromPrdTable();
	showBundleFromPrdButton();
	dialogBundleFromPrd.show();
};

function closeBundleFromPrdDialog() {
	
	var localObjectsToDestroy = {};
	
	localObjectsToDestroy["otherObjects"] = [tableBundleFromPrd];
	localObjectsToDestroy["connections"] = instanceConnectionLinks;
	localObjectsToDestroy["store"] = jsonStoreBundleFromPrdTable;
	localObjectsToDestroy["mainDialog"] = dialogBundleFromPrd;
	
	closeAndDestroyAll(localObjectsToDestroy);
	
	tableBundleFromPrd = null;
	instanceConnectionLinks = [];
	jsonStoreBundleFromPrdTable = null;
	dialogBundleFromPrd = null;
};

function showBundleFromPrdButton() {
	buttonBundleFromPrd = new dijit.form.Button( {
		showLabel : true,
		label : resourceBundle.BundleFromProductButtonReassign,		
		disabled : true,
		onClick : bundleBundleFromPrdSaveClose
	}, 'buttonBundleFromPrdClose');
};

showReassignedInstancesLabel = function(numberOfInstances){
	dojo.html.set(dojo.byId("reassignedInstancesLabel"),formatLabel(resourceBundle.NumberOfInstances, ""+numberOfInstances));
};
function showBundleFromPrdTable() {
	jsonStoreBundleFromPrdTable = new dojox.data.QueryReadStore( {
		url : resourceBundle.contextPath + "/JsonRenderServlet?sessionId="+sessionId,
		requestMethod : "post",
		doClientPaging:true,
		doClientSorting:true
	});
	
	createInstanceTableWidgets();
	
	instanceConnectionLinks.push(dojo.connect(tableBundleFromPrd.grid, "sort", function(info) {
		var deferred = tableBundleFromPrd.grid.selection.getSelectedItems(-1);
		deferred.then(function(selected){
			//Do something on success.
			buttonBundleFromPrd.set('disabled', selected.length<1);
			buttonBundleFromPrd.focus();
			showReassignedInstancesLabel(selected.length);
	    },
	    function(error){
	      //Do something on failure.
			console.log(error);
	  });
	}));
	
	// changeGetSelectedFunction(tableBundleFromPrd);

	selectAllOption = false;	
	var originalToggleAllSelection = dojo.hitch(tableBundleFromPrd.grid.rowSelectCell,tableBundleFromPrd.grid.rowSelectCell.toggleAllSelection);
	
	instanceConnectionLinks.push(dojo.connect(tableBundleFromPrd.grid, "onSelectionChanged", function(item) {
		if(selectAllOption){
			return;
		}		
		var deferred = tableBundleFromPrd.grid.selection.getSelectedItems(-1);
		deferred.then(function(selected){
	      //Do something on success.
			buttonBundleFromPrd.set('disabled', (selected.length<1));
			buttonBundleFromPrd.focus();
		    showReassignedInstancesLabel(selected.length);
	    },
	    function(error){
	      //Do something on failure.
			console.log(error);
	  });

	}));
	
	tableBundleFromPrd.grid.rowSelectCell.toggleAllSelection = function(checked){
		selectAllOption = true;
		var result = originalToggleAllSelection(checked);		
		buttonBundleFromPrd.set('disabled', !checked || tableBundleFromPrd.grid.rowCount<1);
		buttonBundleFromPrd.focus();
	    showReassignedInstancesLabel(checked?tableBundleFromPrd.grid.rowCount:0);
		selectAllOption = false;
		return result;
	};
	

	var firstFetch = true;
	
	instanceConnectionLinks.push(dojo.connect(tableBundleFromPrd.grid, "_onFetchComplete", function(items, req){
		if (firstFetch) {
			var items2=jsonStoreBundleFromPrdTable._items;
			for(i=0; i<items2.length; i++) {
				if (items2[i]['i']['isShared'] === 'true') {
					shareWarningArea.setMessage(resourceBundle.TargetTableShareInstanceHintText);
					shareWarningArea.show();
					break;
				}
			}
			showReassignedInstancesLabel(0);
			if (0 == items2.length) {
				shareWarningArea.setMessage(resourceBundle.TargetTableShareInstanceHintTextEmpty);
				shareWarningArea.show();
			}
			firstFetch = false;
		}
	}));

	tableBundleFromPrd.grid.onFetchError = dojo.hitch(this, onFetchErrorHandler);

};

function extractProdInvIdsAndUpdateTimes(selected){
	prodInvForRebundle=[];
	updateTimeForRebundle=[];
	for (i=0; i<selected.length; i++) {
		var item =selected[i];		
		if (null != item) {
			prodInvForRebundle.push(jsonStoreBundleFromPrdTable.getValue(item,'productInventoryId'));
			updateTimeForRebundle.push(jsonStoreBundleFromPrdTable.getValue(item,'updateTime'));
		}
	}

}

function bundleBundleFromPrdSaveClose() {
	var deferred = tableBundleFromPrd.grid.selection.getSelectedItems(-1);
	deferred.then(function(selected){
        //Do something on success.		
		extractProdInvIdsAndUpdateTimes(selected);
		var prodInv = arrayToString(prodInvForRebundle);
		var formData = 
			"target=reassign&productInventoryId=" + prodInv
			+ "&productId=" + selectedReleaseId + "&sessionId=" + sessionId;

		buttonBundleFromPrd.set('disabled', true);
		buttonBundleFromPrd.focus();

		var dialog1 = showProgressDlgIndicator('bundleBundleFromPrdDlg',resourceBundle.BundleFromProductDialogTitle);
		
		var localObjectsToDestroy = {};
		
		localObjectsToDestroy["progressDlg"] = dialog1;
		localObjectsToDestroy["otherObjects"] = [tableBundleFromPrd];
		localObjectsToDestroy["connections"] = instanceConnectionLinks;
		localObjectsToDestroy["store"] = jsonStoreBundleFromPrdTable;
		localObjectsToDestroy["mainDialog"] = dialogBundleFromPrd;

		sendServletRequestAndCleanup('POST', 'ActionServlet', formData, localObjectsToDestroy, undefined);
	},
    function(error){
      //Do something on failure.
		console.log(error);
  });

	
	
};
