/*
 Licensed Materials - Property of IBM
 5724-T40 IBM License Metric Tool
 5725-C68 IBM Tivoli Asset Discovery for Distributed
 (C) Copyright IBM Corp. 2002, 2011.
 All Rights Reserved. US Government Users Restricted Rights - Use,
 duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 For more detailed help, refer to product manual.
 */

var rowMenu;

function createTreeTableMainMenu() {

	if(dijit.byId('menuRelease') && dijit.byId('menuRelease')!=null){
		//menu already created
		return;
	}
	
	rowMenu = new dijit.Menu( {
		style : 'display: none;'
	}, dojo.byId('table1Menu'));

	rowMenu._destroyOnRemove = true;

	var menuItem1 = new dijit.MenuItem( {
		id : "menuRelease",
		label : resourceBundle.MenuBundleReleases,
		disabled : true,
		iconClass: "claro assignToProduct",
		onClick : function(item) {
			showBundleFromPrdDialog();
		}
	});
	
	var menuItem2 = new dijit.MenuItem( {
		id : "menuInstance",
		label : resourceBundle.MenuBundleInstances,
		disabled : true,
		iconClass: "claro reassignInstance",
		onClick : function(item) {
			showDialog();
		}
	});
	
	var menuItem3 = new dijit.MenuItem( {
		id : "menuConfirm",
		label : resourceBundle.MenuBundleConfirm,
		disabled : true,
		iconClass: "claro confirmInstance",
		onClick : function(item) {
			confirmSelected();
		}
	});

	var menuItem4 = new dijit.MenuItem({
		id: "menuInclude",
        label: resourceBundle.MenuBundleInclude,
        disabled: true,
        iconClass: "claro include",
        onClick: function(item){ 
    		showExcludedTableDialog('true');
 		}
    });

	var menuItem5 = new dijit.MenuItem({
		id: "menuExclude",
        label: resourceBundle.MenuBundleExclude,
        disabled: true,
        iconClass: "claro exclude",
        onClick: function(item){ 
        	showExcludedTableDialog('false');
	 	}
    });

	var menuItem6 = new dijit.MenuItem({
		id: "menuShare",
		label : resourceBundle.MenuBundleShareInstance,
		disabled : true,
		iconClass: "claro share",
		onClick: function(item){ 
			showShareDialog();
 		}
	});
	
	menuItem1._destroyOnRemove = true;
	menuItem2._destroyOnRemove = true;
	menuItem3._destroyOnRemove = true;
	menuItem4._destroyOnRemove = true;
	menuItem5._destroyOnRemove = true;
	menuItem6._destroyOnRemove = true;

	rowMenu.addChild(menuItem1);
	rowMenu.addChild(menuItem2);
	rowMenu.addChild(menuItem3);
	rowMenu.addChild(menuItem4);
	rowMenu.addChild(menuItem5);
	rowMenu.addChild(menuItem6);
}
