connect to tlma%

CREATE PROCEDURE ADM.CREATE_VIEW_IF_NOT_EXISTS(in SCHEMA_NAME char(40), in TABLE_NAME char(40), in COLUMNS_DEFINITION varchar(920), in REST varchar(920))
	BEGIN
		DECLARE numRecords INT DEFAULT 0;
		DECLARE stmt VARCHAR(2000);

		SELECT COUNT(*) INTO numRecords
		FROM SYSCAT.TABLES 
		WHERE TABSCHEMA = SCHEMA_NAME AND TABNAME = TABLE_NAME;
			
		SET stmt = 'CREATE VIEW ' CONCAT SCHEMA_NAME CONCAT '.' CONCAT TABLE_NAME CONCAT '(' CONCAT COLUMNS_DEFINITION CONCAT ')' CONCAT REST;
		IF numRecords = 0 THEN
			PREPARE prep_stmt FROM stmt;
			EXECUTE prep_stmt;
		END IF;
	END%

-- if AGENT_STATUS_V is ported to 7.2.2 the view could exist in database
CALL ADM.CREATE_VIEW_IF_NOT_EXISTS(
	'CUSTOM',
	'AGENT_STATUS_V',	
	'AGENT_ID,	OVERALL_STATUS,	LOCAL_SW_SCAN_CONFIG_CORRUPTED,	SW_CATALOG_CORRUPTED,	LOCAL_SW_SCAN_FAILED,	REMOTE_SWSCAN_CONFIG_CORRUPTED,	REMOTE_SW_SCAN_FAILED,	USE_SETUP_FAILED,	USE_SNAPSHOT_FAILED,	USE_REPORT_FAILED,	HW_SCAN_CONFIG_FILE_CORRUPTED,	HW_SCAN_FAILED,	FULL_HW_SCAN_CONFIG_CORRUPTED,	FULL_HW_SCAN_FAILED,	SCHEDULED_ERROR,	SELF_UPDATE_FAILED,	UNDEFINED_ERROR,	OTHER_ERROR',
	'AS
  SELECT
	a.id,
	a.status,
	CASE WHEN MOD(a.status/32768,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/16384,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/8192,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/4096,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/2048,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/1024,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/512,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/256,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/128,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/64,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/32,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/16,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/8,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/4,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status/2,2) > 0 THEN 1 ELSE 0 END,
	CASE WHEN MOD(a.status,2) > 0 THEN 1 ELSE 0 END
  FROM adm.agent a'
)%

DROP PROCEDURE ADM.CREATE_VIEW_IF_NOT_EXISTS%

GRANT SELECT ON CUSTOM.AGENT_STATUS_V TO USER TLMSRV%

disconnect current%