connect to tlma%

-- procedure to delete existing procedures
create procedure ADM.DROP_PROCEDURE_IF_EXISTS(in PROCEDURE_NAME char(100))
	begin
	declare STMT char(100);
	declare MSG char(20);
	
	declare continue handler for sqlstate '42704' set MSG = 'ok';
	
	set STMT = 'DROP PROCEDURE ' concat PROCEDURE_NAME;
	prepare S1 from STMT;
	execute S1;
end%

call ADM.DROP_PROCEDURE_IF_EXISTS('ADM.DYNAMIC_COLUMN_RESIZE')%	

drop procedure ADM.DROP_PROCEDURE_IF_EXISTS%

CREATE PROCEDURE ADM.DYNAMIC_COLUMN_RESIZE(in COLUMN_SIZE int,in TABSCHEMA_N varchar(15), in TABNAME_N varchar(100),in COLNAME_N varchar(100), in DATATYPE_N varchar (15))
        LANGUAGE SQL
        BEGIN
                DECLARE IS_SIZE_CORRECT INTEGER DEFAULT 1;
                DECLARE STMT VARCHAR(200);
                SELECT (CASE WHEN LENGTH <= COLUMN_SIZE THEN 0 ELSE 1 END)
                INTO IS_SIZE_CORRECT
                FROM SYSCAT.COLUMNS
                WHERE UPPER(TABSCHEMA) = UPPER(TABSCHEMA_N)
                AND UPPER(TABNAME) = UPPER(TABNAME_N)
                AND UPPER(COLNAME) = UPPER(COLNAME_N);
                
                IF IS_SIZE_CORRECT = 0 THEN
                   SET STMT = 'ALTER TABLE ' concat UPPER(TABSCHEMA_N) concat '.' concat UPPER(TABNAME_N) concat ' ALTER COLUMN ' concat UPPER(COLNAME_N) concat ' SET DATA TYPE ' concat DATATYPE_N concat '(' concat RTRIM(CAST(COLUMN_SIZE AS CHAR(15))) concat ')';
                   PREPARE PREP_STMT FROM STMT;
                   EXECUTE PREP_STMT;
                END IF;
        END%                
        
        
        
grant execute on procedure ADM.DYNAMIC_COLUMN_RESIZE to user TLMSRV%

disconnect current%