-- ****************************************************************************
-- * Licensed Materials - Property of IBM
-- * 5724-T40 IBM Tivoli License Metric Tool
-- * 5725-C68 IBM Tivoli Asset Discovery for Distributed
-- *
-- * (C) Copyright IBM Corp. 2013.  All Rights Reserved.
-- *
-- * US Government Users Restricted Rights - Use, duplication or
-- * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-- ****************************************************************************

connect to tlma%

create procedure ADM.DROP_IF_EXISTS(in NAME char(100))
	begin
	declare STMT char(250);
	declare MSG char(20);

	declare continue handler for sqlstate '42704' set MSG = 'ok';

	set STMT = 'DROP ' concat NAME;
	prepare S1 from STMT;
	execute S1;
	end%

call ADM.DROP_IF_EXISTS('index swcat.branch_prod_id')%
call ADM.DROP_IF_EXISTS('index swcat.branch_path')%
call ADM.DROP_IF_EXISTS('index swcat.branch_complex')%
call ADM.DROP_IF_EXISTS('index swcat.branch_type')%
call ADM.DROP_IF_EXISTS('index swcat.branch_deleted')%

create index swcat.branch_prod_id on swcat.branch (product_id) allow reverse scans%
create index swcat.branch_path on swcat.branch (path) allow reverse scans%
create index swcat.branch_complex on swcat.branch (is_complex)%
create index swcat.branch_type on swcat.branch (type)%
create index swcat.branch_deleted on swcat.branch (deleted)%

delete from swcat.control where name='CATIMP_PERF_BOOST'%
insert into swcat.control (name,ctrl_value) values ('CATIMP_PERF_BOOST','true')%

drop procedure ADM.DROP_IF_EXISTS%

runstats on table swcat.branch and indexes all%
disconnect current%