connect to tlma%
--
-- 
create procedure ADM.DROP_IF_EXISTS(in PROLOG char (100), in TYPE char(100), in NAME char(100))
	begin
	declare STMT char(250);
	declare MSG char(20);
	
	declare continue handler for sqlstate '42704' set MSG = 'ok';
	
	set STMT = PROLOG concat ' DROP '  concat TYPE concat '  ' concat  NAME;
	prepare S1 from STMT;
	execute S1;
end%
-- 
-- Remove objects 
-- (data in ADM.AGENT_CHANGES are not crucial) 
-- 
-- TMP_HOST_TRACK_TRG may exist when temporary solution was used
--
call ADM.DROP_IF_EXISTS('','TRIGGER','ADM.TMP_HOST_TRACK_TRG')%
call ADM.DROP_IF_EXISTS('','TRIGGER','ADM.HOST_IP_CHANGE_TRG')%
call ADM.DROP_IF_EXISTS('','INDEX',  'ADM.AGENT_CHANGES_FX_IDX')%
call ADM.DROP_IF_EXISTS('ALTER TABLE ADM.AGENT_CHANGES ','CONSTRAINT','AGENT_CHANGES_PK')%
call ADM.DROP_IF_EXISTS('ALTER TABLE ADM.AGENT_CHANGES ','CONSTRAINT','AGENT_CHANGES_FK')%
call ADM.DROP_IF_EXISTS('','TABLE','ADM.AGENT_CHANGES')%
--
--
-- New table ADM.AGENT_CHANGES
--
CREATE TABLE ADM.AGENT_CHANGES ( ID BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( INCREMENT BY 1 CACHE 20 ),
                                 CHANGE_TIME TIMESTAMP NOT NULL DEFAULT CURRENT TIMESTAMP, 
                                 AGENT_ID BIGINT NOT NULL, 
                                 OLD_HOSTNAME VARCHAR(60), 
                                 OLD_IP_ADDRESS VARCHAR(39),
                                 NEW_HOSTNAME VARCHAR(60), 
                                 NEW_IP_ADDRESS VARCHAR(39))%


ALTER TABLE  ADM.AGENT_CHANGES ADD CONSTRAINT AGENT_CHANGES_PK PRIMARY KEY ( ID )%
ALTER TABLE  ADM.AGENT_CHANGES ADD CONSTRAINT AGENT_CHANGES_FK FOREIGN KEY ( AGENT_ID ) REFERENCES ADM.AGENT ( ID ) ON DELETE CASCADE ON UPDATE NO ACTION%
CREATE INDEX ADM.AGENT_CHANGES_FX_IDX ON   ADM.AGENT_CHANGES (AGENT_ID)%
--added just in case of TLMSRV installation 
--#pragma ignore -551
GRANT SELECT,INSERT,UPDATE,DELETE ON TABLE ADM.AGENT_CHANGES TO USER TLMSRV%
--
--
CREATE TRIGGER ADM.HOST_IP_CHANGE_TRG
AFTER UPDATE OF HOSTNAME, IP_ADDRESS ON ADM.AGENT
REFERENCING OLD AS OLD NEW AS NEW
FOR EACH ROW MODE DB2SQL
    WHEN ( (OLD.HOSTNAME   IS NOT NULL AND NEW.HOSTNAME IS NOT NULL AND OLD.HOSTNAME <> NEW.HOSTNAME) OR 
           (OLD.IP_ADDRESS IS NOT NULL AND NEW.IP_ADDRESS IS  NOT NULL AND OLD.IP_ADDRESS <> NEW.IP_ADDRESS)
         )
INSERT INTO ADM.AGENT_CHANGES (
  AGENT_ID,
  OLD_HOSTNAME,
  OLD_IP_ADDRESS,
  NEW_HOSTNAME,
  NEW_IP_ADDRESS
)
VALUES (
OLD.ID,
OLD.HOSTNAME,
OLD.IP_ADDRESS,
NEW.HOSTNAME,
NEW.IP_ADDRESS
)%
-- clean up 
-- 
drop procedure ADM.DROP_IF_EXISTS%
disconnect current%