-- ****************************************************************************
-- * Licensed Materials - Property of IBM
-- * 5724-T40 IBM License Metric Tool
-- * 5724-S94 IBM Tivoli Asset Discovery for Distributed
-- *
-- * (C) Copyright IBM Corp. 2012.  All Rights Reserved.
-- *
-- * US Government Users Restricted Rights - Use, duplication or
-- * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-- ****************************************************************************

connect to tlma%

create procedure ADM.DROP_FUNCTION_IF_EXISTS(in FUNCTION_NAME char(100))
	begin
	declare STMT char(100);
	declare MSG char(20);
	
	declare continue handler for sqlstate '42704' set MSG = 'ok';
	
	set STMT = 'DROP FUNCTION ' concat FUNCTION_NAME;
	prepare S1 from STMT;
	execute S1;
	end%
	
CALL ADM.DROP_FUNCTION_IF_EXISTS('ADM.NEXT_SCAN_DATE')%

CREATE FUNCTION ADM.NEXT_SCAN_DATE(curr_time TIMESTAMP, inv_start_date TIMESTAMP, inv_rate_type INTEGER, inv_rate_value INTEGER)
	RETURNS TIMESTAMP
	LANGUAGE SQL 
	CONTAINS SQL
	NO EXTERNAL ACTION 
	DETERMINISTIC
BEGIN ATOMIC
DECLARE next_date TIMESTAMP;
DECLARE temp_date TIMESTAMP;
IF (inv_start_date > curr_time) THEN SET next_date = inv_start_date; 
ELSE
IF (inv_rate_type = 0) THEN SET next_date = NULL; ELSE
IF (inv_rate_type = 1) THEN SET next_date = inv_start_date + ((DAYS(curr_time)-DAYS(inv_start_date))/inv_rate_value*inv_rate_value) DAYS; 
 IF (next_date < curr_time) THEN SET next_date=next_date+inv_rate_value DAYS; END IF;
ELSE
IF (inv_rate_type = 2) THEN SET next_date = inv_start_date + ((DAYS(curr_time)-DAYS(inv_start_date))/(7*inv_rate_value)*7*inv_rate_value) DAYS; 
 IF (next_date < curr_time) THEN SET next_date=next_date+(7*inv_rate_value) DAYS; END IF;
ELSE
IF (inv_rate_type = 3) THEN
 SET next_date = inv_start_date;
 WHILE (next_date <= curr_time) DO
   IF (DAY(next_date) <= 28) THEN
     SET next_date = next_date + (((YEAR(curr_time)-YEAR(next_date))*12+MONTH(curr_time)-MONTH(next_date))/inv_rate_value*inv_rate_value) MONTHS; 
     IF (next_date <= curr_time) THEN SET next_date=next_date+inv_rate_value MONTHS; END IF;
   ELSE
     SET temp_date = next_date;
     SET next_date = temp_date + inv_rate_value MONTHS; 
     IF (DAY(next_date) <> DAY(temp_date)) THEN SET next_date=next_date + 1 DAY; END IF;
   END IF;
 END WHILE;
END IF;
END IF;
END IF;
END IF;
END IF;
RETURN next_date ;
END %

GRANT EXECUTE ON FUNCTION ADM.NEXT_SCAN_DATE(TIMESTAMP, TIMESTAMP, INTEGER, INTEGER) TO USER TLMSRV%

CALL ADM.DROP_FUNCTION_IF_EXISTS('ADM.LAST_SCAN_DATE')%

CREATE FUNCTION ADM.LAST_SCAN_DATE(curr_time TIMESTAMP, inv_start_date TIMESTAMP, inv_rate_type INTEGER, inv_rate_value INTEGER)
	RETURNS TIMESTAMP
	LANGUAGE SQL 
	CONTAINS SQL
	NO EXTERNAL ACTION 
	DETERMINISTIC
BEGIN ATOMIC
DECLARE last_date TIMESTAMP;
DECLARE temp_date TIMESTAMP;
IF (inv_start_date > curr_time OR inv_rate_type = 0) THEN SET last_date = inv_start_date; 
ELSE
IF (inv_rate_type = 1) THEN SET last_date = inv_start_date + ((DAYS(curr_time)-DAYS(inv_start_date))/inv_rate_value*inv_rate_value) DAYS; 
 IF (last_date > curr_time) THEN SET last_date=last_date-inv_rate_value DAYS; END IF;
ELSE
IF (inv_rate_type = 2) THEN SET last_date = inv_start_date + ((DAYS(curr_time)-DAYS(inv_start_date))/(7*inv_rate_value)*7*inv_rate_value) DAYS; 
 IF (last_date > curr_time) THEN SET last_date=last_date-(7*inv_rate_value) DAYS; END IF;
ELSE
IF (inv_rate_type = 3) THEN 
 SET temp_date = inv_start_date;
 SET last_date = temp_date;
 WHILE (temp_date <= curr_time) DO
   IF (DAY(last_date) <= 28) THEN
     SET last_date = temp_date + (((YEAR(curr_time)-YEAR(temp_date))*12+MONTH(curr_time)-MONTH(temp_date))/inv_rate_value*inv_rate_value) MONTHS;
     IF (last_date > curr_time) THEN SET last_date=last_date-inv_rate_value MONTHS; END IF;
     SET temp_date = curr_time + 1 DAY;
   ELSE
     SET last_date = temp_date;
     SET temp_date = last_date + inv_rate_value MONTHS; 
     IF (DAY(last_date) <> DAY(temp_date)) THEN SET temp_date=temp_date + 1 DAY; END IF;
   END IF;
 END WHILE;
END IF;
END IF;
END IF;
END IF;
RETURN last_date ;
END %

GRANT EXECUTE ON FUNCTION ADM.LAST_SCAN_DATE(TIMESTAMP, TIMESTAMP, INTEGER, INTEGER) TO USER TLMSRV%

drop procedure ADM.DROP_FUNCTION_IF_EXISTS%

disconnect tlma%
