CONNECT TO TLMA%

CREATE PROCEDURE ADM.ADD_COLUMN_IF_NOT_EXISTS(
      in SCHEMA_NAME char(40), 
      in TABLE_NAME char(40), 
      in COLUMN_NAME char(40),
      in COLUMN_DEFINITION varchar(120))
	BEGIN
		DECLARE numRecords INT DEFAULT 0;
		DECLARE stmt VARCHAR(1000);

		SELECT COUNT(*) INTO numRecords
		FROM SYSCAT.COLUMNS 
		WHERE TABSCHEMA = SCHEMA_NAME AND TABNAME = TABLE_NAME AND COLNAME = COLUMN_NAME;
			
		SET stmt = 'ALTER TABLE ' CONCAT SCHEMA_NAME CONCAT '.' CONCAT TABLE_NAME CONCAT ' ADD COLUMN ' CONCAT COLUMN_DEFINITION;
		IF numRecords = 0 THEN
			PREPARE prep_stmt FROM stmt;
			EXECUTE prep_stmt;
		END IF;
	END%

-- if feature is ported to 7.2.2 the column could exist
CALL ADM.ADD_COLUMN_IF_NOT_EXISTS(
	'ADM',
	'VM_MANAGER',
	'PROTOCOL',
	'PROTOCOL SMALLINT'
)%

comment on column ADM.VM_MANAGER.PROTOCOL is 
    'Communication protocol for VM Manager. For Hyper-V it could be NTLM or Powershell.'%

-- for existing Hyper-V VM Managers the type should be set to NTLM by default
UPDATE adm.vm_manager SET protocol = 0 WHERE type = 1 AND protocol IS NULL%

DROP PROCEDURE ADM.ADD_COLUMN_IF_NOT_EXISTS%

DISCONNECT CURRENT%