connect to tlma%

create procedure ADM.DROP_IF_EXISTS(in NAME char(100))
	begin
	declare STMT char(250);
	declare MSG char(20);
	
	declare continue handler for sqlstate '42704' set MSG = 'ok';
	
	set STMT = 'DROP ' concat NAME;
	prepare S1 from STMT;
	execute S1;
end%
	
call ADM.DROP_IF_EXISTS('PROCEDURE ADM.RPRT_GEN')%     	
call ADM.DROP_IF_EXISTS('TRIGGER ADM.RG_INSERT_T3')%     	

CREATE PROCEDURE ADM.RPRT_GEN()
  LANGUAGE SQL
  BEGIN ATOMIC
   
    FOR v AS cur1 CURSOR FOR 
                select id,CREATION_TIME from adm.REPORT_GROUP where id not in (select DISTINCT REPORT_GROUP_id from adm.IBM_REPORT)
    DO       
      INSERT INTO adm.IBM_REPORT (id, start_date, end_date, customer_id, version, report_group_id) values (
	(select LAST_ID +1  from adm.oid where table_name = 'adm.ibm_report'),
	(select date(value) from adm.control where name = 'DB_CREATION'),
	(date(v.creation_time - 1 day)),
	1,
	(select value from adm.control where name = 'DATABASE_VERSION'),
   	v.id);
   	
   update adm.oid set last_id = last_id +1 where 	table_name = 'adm.ibm_report';
   
    END FOR;
  END%
  
call ADM.RPRT_GEN%  

CREATE TRIGGER ADM.RG_INSERT_T3
AFTER INSERT ON ADM.REPORT_GROUP 
REFERENCING NEW AS N FOR EACH ROW MODE DB2SQL
if (date(n.creation_time) >= (select date(value) +1 day from adm.control where name = 'DB_CREATION') )
then
INSERT INTO adm.ibm_report
(
   id, start_date, end_date, customer_id, version, report_group_id
)
VALUES
(
   (select LAST_ID +1  from adm.oid where table_name = 'adm.ibm_report'),
   (select date(value) from adm.control where name = 'DB_CREATION'),
   (date(n.creation_time - 1 day)),
   1,
   (select value from adm.control where name = 'DATABASE_VERSION'),
   n.id
);
update adm.oid set last_id = last_id +1 where 	table_name = 'adm.ibm_report'; end if
%
  
drop procedure ADM.RPRT_GEN%
drop procedure ADM.DROP_IF_EXISTS%

disconnect current%